#!/usr/bin/python

from PIL import Image, ImageDraw, ImageFont
import math

tile_size = 256

# Load source image
source = Image.open('source2.jpg')
source_size = source.size

# Calc new canvas size
longest_side = source.size[0] if source.size[0] > source.size[1] else source.size[1]
max_size = int(math.pow(2,math.ceil(math.log(longest_side,2))))
canvas_size = (max_size,max_size)
resize_factor = float(max_size) / float(longest_side)

print "Image size: " + str(source_size[0]) + "x" + str(source_size[1]) + " scale to " + str(canvas_size[0]) + "x" + str(canvas_size[1]) + ", longest side: " + str(longest_side) + ", resize factor: " + str(resize_factor)
# Create new source image
canvas = Image.new("RGB", canvas_size, "red")
source = source.resize((int(round(resize_factor*source_size[0])),int(round(resize_factor*source_size[1]))))
source_size = source.size
paste_position = (int(round((canvas_size[0] - source_size[0]) / 2)),int(round((canvas_size[1] - source_size[1]) / 2)))
canvas.paste(source,paste_position)

zoom_factor = int(math.log(max_size/tile_size,2))

print "Processing " + str (zoom_factor) + " zoom levels"

while zoom_factor >= 0:
  print "Level: " + str(zoom_factor) + ", " + str(int(math.ceil(canvas_size[1]/tile_size))) + " rows and " + str(int(math.ceil(canvas_size[0]/tile_size))) + " columns"

  for row in xrange(0,int(math.ceil(canvas_size[1]/tile_size))):
    for column in xrange(0,int(math.ceil(canvas_size[0]/tile_size))):
      print "Column: " + str(column)
      print "Row: " + str(row)
      crop_size = ( int(row*tile_size), int(column*tile_size) ,int((row+1)*tile_size), int((column+1)*tile_size))
      tile = canvas.crop(crop_size)
      tile.save('tile_' + str(zoom_factor) + '_' + str(row) + '_' + str(column) + '.jpg')

  canvas = canvas.resize((int(round(canvas_size[0]/2)),int(round(canvas_size[1]/2))))
  canvas_size = canvas.size
  zoom_factor -= 1